diff --git a/src/iperf_api.h b/src/iperf_api.h
index f48fa30bb..438cd8b7a 100755
--- a/src/iperf_api.h
+++ b/src/iperf_api.h
@@ -335,6 +335,7 @@ enum {
     IESETSCTPNSTREAM= 138,  //  Unable to set SCTP number of streams (check perror)
     IESETSCTPBINDX= 139,    // Unable to process sctp_bindx() parameters
     IESETPACING= 140,       // Unable to set socket pacing rate
+    IESETBUF2= 141,	    // Socket buffer size incorrect (written value != read value)
     /* Stream errors */
     IECREATESTREAM = 200,   // Unable to create a new stream (check herror/perror)
     IEINITSTREAM = 201,     // Unable to initialize stream (check herror/perror)
diff --git a/src/iperf_error.c b/src/iperf_error.c
index a64c2129c..1cfceeba1 100644
--- a/src/iperf_error.c
+++ b/src/iperf_error.c
@@ -359,6 +359,10 @@ iperf_strerror(int i_errno)
 	    snprintf(errstr, len, "unable to set socket pacing");
 	    perr = 1;
 	    break;
+	case IESETBUF2:
+	    snprintf(errstr, len, "socket buffer size not set correctly");
+	    break;
+	
     }
 
     if (herr || perr)
diff --git a/src/iperf_tcp.c b/src/iperf_tcp.c
index d22dd0ec3..b18bd54d1 100644
--- a/src/iperf_tcp.c
+++ b/src/iperf_tcp.c
@@ -324,6 +324,7 @@ iperf_tcp_connect(struct iperf_test *test)
     struct addrinfo hints, *local_res, *server_res;
     char portstr[6];
     int s, opt;
+    socklen_t optlen;
     int saved_errno;
 
     if (test->bind_address) {
@@ -413,18 +414,43 @@ iperf_tcp_connect(struct iperf_test *test)
             return -1;
         }
     }
+
+    /* Read back and verify the sender socket buffer size */
+    optlen = sizeof(opt);
+    if (getsockopt(s, SOL_SOCKET, SO_SNDBUF, &opt, &optlen) < 0) {
+	saved_errno = errno;
+	close(s);
+	freeaddrinfo(server_res);
+	errno = saved_errno;
+	i_errno = IESETBUF;
+	return -1;
+    }
+    if (test->settings->socket_bufsize && test->settings->socket_bufsize != opt) {
+	i_errno = IESETBUF2;
+	return -1;
+    }
     if (test->debug) {
-	socklen_t optlen = sizeof(opt);
-	if (getsockopt(s, SOL_SOCKET, SO_SNDBUF, &opt, &optlen) < 0) {
-	    saved_errno = errno;
-	    close(s);
-	    freeaddrinfo(server_res);
-	    errno = saved_errno;
-	    i_errno = IESETBUF;
-	    return -1;
-	}
 	printf("SO_SNDBUF is %u\n", opt);
     }
+
+    /* Read back and verify the receiver socket buffer size */
+    optlen = sizeof(opt);
+    if (getsockopt(s, SOL_SOCKET, SO_RCVBUF, &opt, &optlen) < 0) {
+	saved_errno = errno;
+	close(s);
+	freeaddrinfo(server_res);
+	errno = saved_errno;
+	i_errno = IESETBUF;
+	return -1;
+    }
+    if (test->settings->socket_bufsize && test->settings->socket_bufsize != opt) {
+	i_errno = IESETBUF2;
+	return -1;
+    }
+    if (test->debug) {
+	printf("SO_RCVBUF is %u\n", opt);
+    }
+
 #if defined(HAVE_FLOWLABEL)
     if (test->settings->flowlabel) {
         if (server_res->ai_addr->sa_family != AF_INET6) {
diff --git a/src/iperf_udp.c b/src/iperf_udp.c
index 8dd0acfdb..44c1f272a 100644
--- a/src/iperf_udp.c
+++ b/src/iperf_udp.c
@@ -233,6 +233,8 @@ iperf_udp_accept(struct iperf_test *test)
      * receiving so that we can cover both normal and --reverse operation.
      */
     int opt;
+    socklen_t optlen;
+    
     if ((opt = test->settings->socket_bufsize)) {
         if (setsockopt(s, SOL_SOCKET, SO_RCVBUF, &opt, sizeof(opt)) < 0) {
             i_errno = IESETBUF;
@@ -244,6 +246,34 @@ iperf_udp_accept(struct iperf_test *test)
         }
     }
 
+    /* Read back and verify the sender socket buffer size */
+    optlen = sizeof(opt);
+    if (getsockopt(s, SOL_SOCKET, SO_SNDBUF, &opt, &optlen) < 0) {
+	i_errno = IESETBUF;
+	return -1;
+    }
+    if (test->settings->socket_bufsize && test->settings->socket_bufsize != opt) {
+	i_errno = IESETBUF2;
+	return -1;
+    }
+    if (test->debug) {
+	printf("SO_SNDBUF is %u\n", opt);
+    }
+
+    /* Read back and verify the receiver socket buffer size */
+    optlen = sizeof(opt);
+    if (getsockopt(s, SOL_SOCKET, SO_RCVBUF, &opt, &optlen) < 0) {
+	i_errno = IESETBUF;
+	return -1;
+    }
+    if (test->settings->socket_bufsize && test->settings->socket_bufsize != opt) {
+	i_errno = IESETBUF2;
+	return -1;
+    }
+    if (test->debug) {
+	printf("SO_RCVBUF is %u\n", opt);
+    }
+
 #if defined(HAVE_SO_MAX_PACING_RATE)
     /* If socket pacing is specified, try it. */
     if (test->settings->fqrate) {
@@ -339,6 +369,8 @@ iperf_udp_connect(struct iperf_test *test)
      * receiving so that we can cover both normal and --reverse operation.
      */
     int opt;
+    socklen_t optlen;
+    
     if ((opt = test->settings->socket_bufsize)) {
         if (setsockopt(s, SOL_SOCKET, SO_RCVBUF, &opt, sizeof(opt)) < 0) {
             i_errno = IESETBUF;
@@ -349,6 +381,33 @@ iperf_udp_connect(struct iperf_test *test)
             return -1;
         }
     }
+    /* Read back and verify the sender socket buffer size */
+    optlen = sizeof(opt);
+    if (getsockopt(s, SOL_SOCKET, SO_SNDBUF, &opt, &optlen) < 0) {
+	i_errno = IESETBUF;
+	return -1;
+    }
+    if (test->settings->socket_bufsize && test->settings->socket_bufsize != opt) {
+	i_errno = IESETBUF2;
+	return -1;
+    }
+    if (test->debug) {
+	printf("SO_SNDBUF is %u\n", opt);
+    }
+
+    /* Read back and verify the receiver socket buffer size */
+    optlen = sizeof(opt);
+    if (getsockopt(s, SOL_SOCKET, SO_RCVBUF, &opt, &optlen) < 0) {
+	i_errno = IESETBUF;
+	return -1;
+    }
+    if (test->settings->socket_bufsize && test->settings->socket_bufsize != opt) {
+	i_errno = IESETBUF2;
+	return -1;
+    }
+    if (test->debug) {
+	printf("SO_RCVBUF is %u\n", opt);
+    }
 
 #if defined(HAVE_SO_MAX_PACING_RATE)
     /* If socket pacing is available and not disabled, try it. */
